* commands to generate results in blog post at http://blogs.cgdev.org/open_book/2011/03/response-to-pitts-response-to-roodman-and-morduchs-replication-of-etc.php
log using MPBlog_post1, text replace
use "Roodman & Morduch HH 3-11.dta", clear
* For more on variables, see http://www.cgdev.org/doc/RM/variable%20list.pdf

global covsy scohead  afedhighns  amedhighns  afadultd  amadultd  sexhead  agehead  llandbef  edheadns  hdbrolndd  hdsislndd  hdparlndd  spbrolndd  spsislndd  spparlndd  _Iwave*
global covsf scohead1 afedhighns1 amedhighns1           amadultd1 sexhead1 agehead1 llandbef1 edheadns1 hdbrolndd1 hdsislndd1 hdparlndd1 spbrolndd1 spsislndd1 spparlndd1
global covsm scohead1 afedhighns1 amedhighns1 afadultd1           sexhead1 agehead1 llandbef1 edheadns1 hdbrolndd1 hdsislndd1 hdparlndd1 spbrolndd1 spsislndd1 spparlndd1
global villagechars primcoed hpruralh hpfampln hpmidwif pzrice pzwflour pzmoil pzhegg pzmilk pzpotato wagef nowagef wagem bamtr
global creditvars lfbraclv lmbraclv lfbrdblv lmbrdblv lfgramlv lmgramlv
* global creditvars lfproglv lmproglv
global xvars $creditvars $covsy

xi i.village i.wave

* For first-stage eqs, make variables based on first-wave data only
sort nh wave
foreach var in pksamplef pksamplem lfproglv lmproglv scohead  afedhighns  amedhighns  afadultd  amadultd  sexhead  agehead  llandbef  edheadns  hdbrolndd  hdsislndd  hdparlndd  spbrolndd  spsislndd  spparlndd {
	by nh: gen double `var'1 = `var'[1]
}	



* 2SLS

* interact controls with choice dummies to make instruments
foreach var of varlist $covsf _Ivill* {
	gen double zf`var' = `var' * pksamplef1
}
foreach var of varlist $covsm _Ivill* {
	gen double zm`var' = `var' * pksamplem1
}
unab zvill : z*vill*
set maxiter 100
xtabond2 lpcnsexppk $xvars nontar _Ivill* [pw=weight] if pksample, iv($covsy nontar _Ivill* z* pksamplef1 pksamplem1, eq(lev)) robust small h(1) art(0)
* equivalent, more intuitive command:
 ivreg2 lpcnsexppk $covsy nontar _Ivill*         ($creditvars = z* pksamplef1 pksamplem1) [pw=weight] if pksample, cluster(nh) small noid
ivreg2 lpcnsexppk $covsy nontar _Ivill*         ($creditvars = z* pksamplef1 pksamplem1) [pw=weight] if pksample, cluster(nh) small noid gmm2s
ivregress gmm lpcnsexppk $covsy nontar _Ivill*         ($creditvars = z* pksamplef1 pksamplem1) [pw=weight] if pksample, cluster(nh) small
estat overid, forceweights
ivregress gmm lpcnsexppk $covsy nontar _Ivill*         ($creditvars = z* pksamplef1 pksamplem1) [pw=weight] if pksample, cluster(nh) small igmm
estat overid, forceweights
log close
