drop _all
capture log close
log using hansen2_censorweights500, text replace
set seed 3799833
clear
drop _all
matrix drop _all
capture program drop loop1
program define loop1
scalar ig=1
while ig < 501 {
 display ig
 drop _all
 clear
set matsize 5000
 scalar ig=ig+1
set obs 90 // # of villages
gen vill = _n
gen common = invnorm(uniform())
gen mu = sqrt(0.8)*invnorm(uniform()) + sqrt(0.2)*common
gen mupoorf = sqrt(0.5)*invnorm(uniform()) + sqrt(0.5)*common
expand 100  // # of HH/village
gen x1 = uniform() - 0.5
gen x2 = uniform() - 0.5
gen land = uniform()
gen choice = land<0.5
gen program=invnorm(uniform())
gen choicef = choice & (program < -0.75)
gen e = invnorm(uniform())
gen ef = sqrt(2)*e + sqrt(2)*invnorm(uniform())
gen em = -sqrt(2)*e + sqrt(2)*invnorm(uniform())
* coefficients to be estimated
gen creditf = 1.0+2*x1 + 3*x2 + 1*land + 2*ef + 4*mupoorf
replace creditf = 0 if creditf < 2 | choicef==0
* coefficients to be estimated
gen y = 2*x1 + 2*x2 + 1*land+ 1.5*creditf + 2*e + 3*mu
* weights
gen weights = uniform()
*oversample on the basis of choice
replace weights = weights*0.5 if choicef==1
* 2SLS recovers the coefficients on credit too, but with larger standard errors
gen zf = choicef
xi i.vill
unab dummies: _Ivill*
foreach var in `dummies' x1 x2 land {
		gen zf`var' = zf * `var'
}
ivreg2 y x1 x2 land _Ivill* (creditf = zf*) [pw=weight]
mat b=get(_b)
mat b1 =nullmat(b1)\b[1,1]
mat b2 =nullmat(b2)\b[1,2]
mat sarganp=e(sarganp)
mat sarganp1=nullmat(sarganp1)\sarganp
mat jp=e(jp)
mat jp1=nullmat(jp1)\jp
scalar jdf=e(jdf)
predict eps,r
regress eps x1 x2 land _Ivill* zf*
scalar j2= 1-chi2(jdf,e(r2)*e(N))
mat sg1=nullmat(sg1)\j2
testparm zf*
scalar hansen1=1-chi2(jdf,(jdf+1)*r(F))
mat hansen=nullmat(hansen)\hansen1
*matrix list b
*matrix list sarganp
*matrix list jp

 }
end
quietly loop1
drop _all

svmat b1
svmat b2
*svmat sarganp1
svmat jp1
svmat sg1
svmat hansen
corr jp* sg*
count if sg11 < 0.05
count if jp11 < 0.05
save hansen2_censorweights500, replace
summ
log close

